.dialog {
  background: var(--color-background);
  border-radius: var(--border-radius-lg);

  display: grid;
  grid-template-rows: auto 1fr auto;

  overflow: hidden;
}

.backdrop {
  margin: 0;
  padding: 0;
  width: initial;
  height: initial;
  max-width: none;
  max-height: none;

  display: none;

  background: #000000B0;
  border: none;

  color: inherit;
}

.backdrop[open] {
  display: grid;
  place-content: center;
}

.header {
  position: relative; /* For close button placement. */
  padding: var(--margin);

  display: flex;
  align-items: center;

  transition: background var(--transition-duration);
}

/* When the dialog content is scrolled, the header bar is highlighted. */
.header.highlight {
  background: var(--color-background-d1);
}

.title {
  margin: 0;
  font-size: 1.2rem;
  font-weight: 500;

  flex: 1;
}

.confirm {
  display: none;
}

.close {
  position: absolute;
  display: none;
}

.content {
  overflow-y: scroll;

  display: flex;
  flex-direction: column;
}

.footer {
  padding: var(--margin);

  display: flex;
  flex-direction: column;
  gap: var(--margin-sm);
}

/* Variations */
@media (width < 940px) {
  /* On mobile, medium and large dialogs take the whole screen. */
  /* They also loses their round corners. */
  .dialog:is(.medium, .large) {
    width: 100vw;
    height: 100vh;

    border-radius: 0;
  }

  /* On mobile, medium and large dialogs headers have a background since they take the whole screen. */
  .dialog:is(.medium, .large) .header {
    background: var(--color-background-d1);
  }

  /* On mobile, medium and large dialogs have no footer, since the controls are in the header instead. */
  .dialog:is(.medium, .large) .footer {
    display: none;
  }

  /* On mobile, medium and large dialogs have a close button to the left. */
  .dialog:is(.medium, .large) .close {
    position: initial;
    order: -1;

    display: inline-flex;
  }

  /* On mobile, medium and large dialogs have their confirm button to the right. */
  .dialog:is(.medium, .large) .confirm {
    display: inline-flex;
  }
}

@media (width >= 940px) {
  /* On desktop, medium dialogs are spaced from the window borders and have a max width of 700px. */
  .dialog.medium {
    width: calc(100vw - 2 * var(--margin-lg));
    max-width: 700px;
    height: initial;
    margin: var(--margin-lg) 0;
  }

  /* On desktop, large dialogs are spaced from the window borders, are full height and have a max width of 1280px. */
  .dialog.large {
    width: calc(100vw - 2 * var(--margin-lg));
    height: calc(100vh - 2 * var(--margin-lg));
    max-width: 1280px;
  }

  /* On desktop, medium and large dialogs have a close button to the right. */
  .dialog:is(.medium, .large) .close {
    top: var(--margin-sm);
    right: var(--margin-sm);

    display: inline-flex;
  }
}

/* When the header has an icon, it is shown above the title. */
/* The title and the icon are also bigger. */
.header.icon {
  padding: var(--margin-lg);
  padding-bottom: var(--margin);

  flex-direction: column;
  gap: var(--margin);
}

.header.icon :global(.icon) {
  text-align: center;
  font-size: 2rem;
}

.header.icon .title {
  text-align: center;
  font-size: 1.5rem;
  font-weight: 400;
}

/* Aligns the buttons to the end. */
.footer.align-end {
  flex-direction: row-reverse;
  align-items: end;
}